//-------------------------------------------------------------------------------------
//          Copyright ? 2005-2006 META                                             
//                All Rights Reserved.                                                 
//   The file is generated by Component Wizard for QUALCOMM Mobile Platform            
// FileName:   downloadDep.cpp                                                                      
// Author:    nick                          
// Date:       2006-02-22 
//Function: implement IMetaDB interface
// Log:   Author             Date             Description                              
// ------------------------------------------------------------------------------------
//       nick        2009-02-23       Initiate version                                
//-------------------------------------------------------------------------------------
//
//when       who     what, where, why
//--------   ---     ----------------------------------------------------------
//2009-02-23 nick    source management utility, called by perl to download .dep from server

#include "baseTsd.h"
#include "http.h"
#include <windows.h>
#include <stdio.h>
#include <TCHAR.H>
#include <wininet.h>
#include "..\\common\\common.h"

#pragma comment(lib, "Wininet.lib")
extern LPCTSTR DepDirectoryName;

/*
bool getDependFileName(LPCTSTR srcFileName, LPTSTR depFileName)
{
	LPTSTR ptr;
	TCHAR homePath[MY_MAX_PATH];
	bool result = false;	
	if (GetCurrentDirectory(MY_MAX_PATH, homePath))
	{
		//get dep file name
		if ((ptr = _tcsrchr(srcFileName, _T('\\')))!= NULL)
		{
			//ptr starts with "\"
			_stprintf(depFileName, _T("%s\\%s%s"), homePath, DepDirectoryName, ptr);
			if ((ptr = _tcsrchr(depFileName, _T('.'))) != NULL)
			{
				_tcscpy(ptr, _T(".dep"));
				result = true;
			}
		}
	}
	return result;
} 
*/

bool getDepListFileName(LPCSTR projectName, LPCSTR shortName, LPTSTR longName)
{
	int length;
	bool result = false;
	TCHAR wzFileName[MAX_PATH];
	if (GetCurrentDirectory(MY_MAX_PATH, longName))
	{
		ansi2unicode(shortName, wzFileName);
		net2path(wzFileName);
		length = _tcslen(longName);
		_stprintf(longName + length, _T("\\..\\%hs\\metafile\\%s"), projectName, wzFileName);
		result = true;
	}
	return result;
}

bool getDependFile(LPCTSTR srcFileName, LPCSTR projectName)
{
	bool result = false;
	int length;
	WCHAR depFileName[MY_MAX_PATH];
	WCHAR url[HTTP_BUFFER_LENGTH];
	WCHAR wzProjectName[64];

	ansi2unicode(projectName, wzProjectName);

	if (getDependFileName(wzProjectName, srcFileName, depFileName))
	{			
		if (getServerUrl(url))
		{
			length = wcslen(url);
			swprintf(url+length, _T("depend?%s,%s,0,0"), wzProjectName, srcFileName);
			if (downloadFile(url, depFileName)>0)
			{
				result = true;
			}
		}		
	}
	else
	{
		mywPrintf(L"download depend url %s  file %s failed\n", url, depFileName);
	}

	return result;
}



bool doDownloadDep(LPSTR srcFileName, LPCSTR projectName)
{
	bool result = false;
	WCHAR wzName[MY_MAX_PATH];
	LPSTR ptr;
	if ((ptr = strrchr(srcFileName, '.')) != NULL)
	{
		if (stricmp(ptr, ".c") == 0|| stricmp(ptr, ".cpp") == 0)
		{			
			ansi2unicode(srcFileName, wzName);
			net2path(wzName);
			if (getDependFile(wzName, projectName))
			{
				result = true;
			}	
		}
	}
	return result;
}

// here we have the long file name problem and should be solved later by using "quotes"
int downloadDep(LPCSTR fileName, LPCSTR projectName)
{
	FILE* stream = NULL;
	int counter = 0, length;
	char buffer[MAX_PATH];
	TCHAR longName[MY_MAX_PATH];

	if (getDepListFileName(projectName, fileName, longName))
	{
		if ((stream = _tfopen(longName, _T("r")))!= NULL)
		{
			while (fgets(buffer, MAX_PATH, stream))
			{
				//remove last return character
				length = strlen(buffer);
				buffer[length-1]= '\0';
				
				if (doDownloadDep(buffer, projectName))
				{
					counter ++;
				}
				//ignore possible error !!! because server may not have .dep for all .c file, i.e.  mif.c 
			}
			if (!feof(stream))
			{
				return 0;
			}
			fclose(stream);
		}
	}
	return counter;
}

bool downloadList(LPCSTR szFileName, LPCSTR projectName)
{
	char buffer[MAX_PATH];
	sprintf(buffer, "..\\%s\\metaFile\\%s", projectName, szFileName);
	//myPrintf("about to download project %s file %s\n", projectName, buffer);
	if (downloadFileHelper(projectName, buffer, L"list"))
	{
		myPrintf("download list file %s successfully\n", buffer);
		return true;
	}
	else
	{
		myPrintf("download list file %s failed\n", buffer);
		return false;
	}
}

bool downloadSingleFile(LPSTR szFileName, LPSTR projectName)
{
	char buffer[MAX_PATH];
	sprintf(buffer, "..\\%s\\metaFile\\%s", projectName, szFileName);
	//myPrintf("about to download project %s file %s\n", projectName, buffer);
	if (downloadFileHelper(projectName, buffer, L"source@arm", true))
	{
		myPrintf("download list file %s successfully\n", buffer);
		return true;
	}
	else
	{
		myPrintf("download list file %s failed\n", buffer);
		return false;
	}
}


bool checkArgument(int argc, char** argv)
{
	if (argc  != 4)
	{
		return false;
	}

	if (stricmp(argv[1], "-download")==0)
	{
		downloadSingleFile(argv[2], argv[3]);
	}

	if (stricmp(argv[1], "-dep") == 0)
	{
		myPrintf("before download dep file list %s file\n", argv[2]);
		downloadDep(argv[2], argv[3]);
	}

	if (stricmp(argv[1], "-list") == 0)
	{
		downloadList(argv[2], argv[3]);
	}
	return true;
}

int main(int argc, char** argv)
{	
	myPrintf("downloadDep running of argv[1]= %s argv[2]=%s, argv[3]=%s...\n", argv[1], argv[2], argv[3]);
	if (checkArgument(argc, argv))
	{
		return 0;
	}
	return 1;
}

